{g-vars.i &vsh = "shared"}
{show-header-frame-def.i}

screen-title = "Reservations".

def var sprog as char init ?.
def var selection as char init ?.

def buffer b-rate for rate.
def buffer b-room for room.
def buffer b-res2 for reservation.
def buffer b-res for reservation.
def buffer b-out for checkout.
def buffer b-out-room for checkout-room.
def buffer b-out-room2 for checkout-room.
def buffer b-guest for guest.
def buffer b-res-room for reservation-rooms.

def query q-guest for b-guest.
def browse brws-guest query q-guest
   display b-guest.guest-id
           b-guest.first-name
           b-guest.last-name
           b-guest.date-of-birth
   with 5 down title "Choose Guest".

def var r-checkin like reservation.checkin.
def var r-checkout like reservation.checkout.
def var r-id like reservation.reservation-id.
def var r-discount like reservation.discount.
def var r-state as char format "x(1)" label "State".
def var r-state-name as char format "x(11)".

def var g-id like guest.guest-id.
def var g-f-n like guest.first-name.
def var g-l-n like guest.last-name.
def var g-dob like guest.date-of-birth.
def var g-phone# like guest.phone-number.
def var r-rooms like reservation-rooms.rooms.
def var r-type as char label "Type" format "x(15)".

form r-id 
     r-checkin
     r-checkout
     skip
     r-state r-state-name no-label r-discount to 49 skip
     skip
     g-id     at row 3 col 20 colon-aligned
     g-f-n    at row 4 col 20 colon-aligned
     g-l-n    at row 5 col 20 colon-aligned
     g-dob    at row 6 col 20 colon-aligned
     g-phone# at row 7 col 20 colon-aligned 
     with frame f-res size 80 by 20 at row 2 col 1 title "Reservation Management" side-labels.

form r-type r-rooms with 
     frame f-res-rooms title "Reserved Rooms"
     10 down.
     
frame f-res-rooms:frame = frame f-res:handle.
frame f-res-rooms:col = 40.
frame f-res-rooms:row = 5.

form brws-guest with frame f-guests no-box overlay centered size 80 by 9.

def query q-res for reservation scrolling.
open query q-res for each reservation 
   where /* reservation.checkin >= today and */ reservation.state <> 'C' no-lock use-index idx-r-checkin.

def var guest-names as char extent 4.
form b-out-room.guest-ids[1] label "Guest 1" help "Enter ? to search" guest-names[1] format "x(30)" no-label skip
     b-out-room.guest-ids[2] label "Guest 2" help "Enter ? to search" guest-names[2] format "x(30)" no-label skip
     b-out-room.guest-ids[3] label "Guest 3" help "Enter ? to search" guest-names[3] format "x(30)" no-label skip
     b-out-room.guest-ids[4] label "Guest 4" help "Enter ? to search" guest-names[4] format "x(30)" no-label skip
   with side-labels frame f-room-guests centered overlay size 60 by 6.

procedure refresh.
   find reservation where reservation.reservation-id = r-id no-lock no-error.

   if not avail(reservation) then do:
      clear frame f-res all.
      return.
   end.
   
   find b-res where recid(b-res) = recid(reservation) no-lock no-error.

   r-id = b-res.reservation-id.
   r-checkin = b-res.checkin.
   r-checkout = b-res.checkout.
   r-discount = b-res.discount.
   r-state = b-res.state.
   g-id = b-res.guest-id.
   
   find b-guest where b-guest.guest-id = g-id no-lock no-error.
   if avail(b-guest) then do:
      g-f-n = b-guest.first-name.
      g-l-n = b-guest.last-name.
      g-dob = b-guest.date-of-birth.
      g-phone# = b-guest.phone-number.
   end.
   else do:
      g-f-n = "".
      g-l-n = "".
      g-dob = ?.
      g-phone# = "".
   end.
   
   case r-state:
      when "P" then r-state-name = "Placed".
      when "C" then r-state-name = "Canceled".
      when "I" then r-state-name = "CheckedIn".
      when "O" then r-state-name = "CheckedOut".
      otherwise r-state-name = "n/a".
   end.
   
   display r-id 
           r-checkin
           r-checkout
           r-discount
           r-state
           r-state-name
           g-id
           g-f-n
           g-l-n
           g-dob
           g-phone# 
           with frame f-res.

    clear frame f-res-rooms all.
    for each b-res-room where b-res-room.reservation-id = r-id:
       r-type = room-types[b-res-room.type-of-room].
       r-rooms = b-res-room.rooms.
       
       display r-type r-rooms with frame f-res-rooms.
       down 1 with frame f-res-rooms.
    end.
end.

procedure choose-guest.
   def output param g-id as int init ?.

   G-SEARCH:
   repeat on endkey undo, leave:
      def button btn-ok label "Find".
      def button btn-cancel label "Cancel".
      
      form g-f-n skip
           g-l-n skip
           g-dob skip
           btn-ok
           btn-cancel
           with frame f-search side-labels overlay at row 2 col 1 title "Find Guest"
                cancel-button btn-cancel default-button btn-ok.
      
      update g-f-n g-l-n g-dob with frame f-search.
      
      if g-f-n = "" and g-l-n = "" and g-dob = ?
      then do:
         message "Enter at least one search criteri!".
         next g-search.
      end.
      
      def var t-f-guests as int.
      t-f-guests = 0.
      g-id = ?.
      
      for each b-guest 
         where (if g-f-n = ? or g-f-n = "" then true else b-guest.first-name matches g-f-n + "*") and 
               (if g-l-n = ? or g-l-n = "" then true else b-guest.last-name matches g-l-n + "*") and
               (if g-dob = ? then true else b-guest.date-of-birth = g-dob) no-lock:
          
         t-f-guests = t-f-guests + 1.

         if t-f-guests = 1
            then g-id = b-guest.guest-id.
            else if t-f-guests >= 2 then leave.
      end.

      if t-f-guests > 0 then do:
      
         if t-f-guests = 1 then do:
            leave g-search.
         end.
         
         open query q-guest for each b-guest
            where (if g-f-n = ? or g-f-n = "" then true else b-guest.first-name matches g-f-n + "*") and 
               (if g-l-n = ? or g-l-n = "" then true else b-guest.last-name matches g-l-n + "*") and
               (if g-dob = ? then true else b-guest.date-of-birth = g-dob).

         update brws-guest with frame f-guests.
         hide frame f-guests no-pause.
            
         g-id = b-guest.guest-id.

         leave g-search.
      end.
      else do:
         message "Guest not found! Add new guest?" view-as alert-box buttons yes-no update g-add as logical.
         
         if g-add then do:
            do transaction on error undo, leave
                           on endkey undo, leave:
               find last b-guest use-index idx-g-id no-lock no-error.
               g-id = (if avail b-guest then b-guest.guest-id + 1 else 1).
               release b-guest.

               create b-guest.
               assign b-guest.guest-id = g-id.

               form b-guest.guest-id at row 1 col 20 colon-aligned
                    b-guest.first-name at row 2 col 20 colon-aligned
                    b-guest.last-name at row 3 col 20 colon-aligned
                    b-guest.date-of-birth at row 4 col 20 colon-aligned
               with frame f-add-guest overlay centered title "Add guest" side-labels.
               
               display b-guest.guest-id with frame f-add-guest.
               
               update b-guest.first-name
                      b-guest.last-name
                      b-guest.date-of-birth
                      with frame f-add-guest.
               hide frame f-add-guest no-pause.
               release b-guest.
            end.
            
            leave G-SEARCH.
         end.
      end.
   end.
   
   hide frame f-search no-pause.
end.


on "leave" of b-out-room.guest-ids[1] in frame f-room-guests or
   "leave" of b-out-room.guest-ids[2] in frame f-room-guests or
   "leave" of b-out-room.guest-ids[3] in frame f-room-guests or
   "leave" of b-out-room.guest-ids[4] in frame f-room-guests
do:
   def var g-id as int.
   
   if focus:screen-value = "?" then do:
      run choose-guest(output g-id).
      
      if g-id = ? then return no-apply.
      
      focus:screen-value = string(g-id).
   end.
   else g-id = int(focus:screen-value).
   
   if g-id <> 0 then do:
      find b-guest where b-guest.guest-id = g-id no-lock.
      focus:next-sibling:screen-value = b-guest.first-name + " " + b-guest.last-name.
   end.
end.

on "return" of g-id in frame f-res do:
   if g-id:screen-value = "?" then do:
   
      run choose-guest(output g-id).
      
      display g-id with frame f-res.

      g-f-n = "".
      g-l-n = "".
      g-dob = ?.

      return no-apply.
   end.
end.

get first q-res.
if avail reservation then r-id = reservation.reservation-id.
run refresh.

PROC:
repeat:
   {show-header.i}
   
   sprog = ?.
   case selection:
      when "P" then do:
         get prev q-res.
         if not avail reservation then do:
            get first q-res.
         end.

         if avail reservation then do:
            r-id = reservation.reservation-id.
            run refresh.
         end.
      end.
      when "N" then do:
         get next q-res.
         if not avail reservation then do:
            get last q-res.
         end.

         if avail reservation then do:
            r-id = reservation.reservation-id.
            run refresh.
         end.
      end.
      when "F" then do:
         get first q-res.

         if avail reservation then do:
            r-id = reservation.reservation-id.
            run refresh.
         end.
      end.
      when "L" then do:
         get last q-res.

         if avail reservation then do:
            r-id = reservation.reservation-id.
            run refresh.
         end.
      end.
      
      when "I" then do:
         /* find by name, date of birth */
         def button btn-ok label "Find".
         def button btn-cancel label "Cancel".
         
         form g-f-n skip
              g-l-n skip
              g-dob skip
              btn-ok
              btn-cancel
              with frame f-res-search side-labels overlay at row 2 col 1 title "Find Reservation"
                   cancel-button btn-cancel default-button btn-ok.

         on "choose" of btn-cancel in frame f-res-search do:
            apply "f4" to frame f-res-search.
         end.
         on "choose" of btn-ok in frame f-res-search do:
            apply "go" to frame f-res-search.
         end.

         G-SEARCH:
         repeat on endkey undo, leave:
            g-f-n = "".
            g-l-n = "".
            g-dob = ?.
            update g-f-n g-l-n g-dob btn-ok btn-cancel with frame f-res-search.
            
            if g-f-n = "" and g-l-n = "" and g-dob = ?
            then do:
               message "Enter at least one search criteria!".
               next g-search.
            end.
      
            for each b-guest 
               where (if g-f-n = ? or g-f-n = "" then true else b-guest.first-name matches g-f-n + "*") and 
                     (if g-l-n = ? or g-l-n = "" then true else b-guest.last-name matches g-l-n + "*") and
                     (if g-dob = ? then true else b-guest.date-of-birth = g-dob) no-lock,
                first b-res where b-res.guest-id = b-guest.guest-id and b-res.checkout >= today use-index idx-r-checkin:
                
                r-id = b-res.reservation-id.
                leave.
            end.
            
            leave.
         end.

         hide frame f-res-search no-pause.
         find reservation where reservation.reservation-id = r-id no-lock no-error.
         if avail reservation then do:
            reposition q-res to rowid rowid(reservation).
            get next q-res.
            run refresh.
         end.
      end.
      when "A" then do:
         r-id = (if avail reservation then reservation.reservation-id else ?).
         
         ADD-RES:
         repeat transaction on error undo, leave
                            on endkey undo, leave:
            /*
               step 1: create new reservation id
               step 2: enter checkin/checkout dates
               step 3: enter discount/set state
               step 4: set new guest ID - enter "?" to choose/search guest, where a new guest can be added
               step 5: enter how many rooms and for each count, the room type
                  -> check if the room is available....
            */
            CREATE-RES:
            repeat on error undo, next:
               find last b-res use-index idx-r-id no-lock no-error.
               r-id = (if avail b-res then b-res.reservation-id + 1 else 1).
               release b-res.

               create b-res.
               assign b-res.reservation-id = r-id.
               leave CREATE-RES.
            end.
   
            clear frame f-res all.
            clear frame f-res-rooms all.
            display r-id
                    with frame f-res.
            
            def var r-del as log.
            r-del = yes.
            
            r-checkin = ?.
            r-checkout = ?.

            UPDATE-RES:
            repeat on endkey undo ADD-RES, leave ADD-RES
                   on error undo ADD-RES, leave ADD-RES:
               update r-checkin
                      validate (r-checkin >= today, "Checkin must be greater or equal than " + string(today)) 
                      with frame f-res.

               update r-checkout
                      validate (r-checkout > r-checkin, "Checkout must be greater than" + string(r-checkin))
                      with frame f-res.
                      
               b-res.checkin = r-checkin.
               b-res.checkout = r-checkout.
               
               repeat on endkey undo, next UPDATE-RES
                      on error undo, next UPDATE-RES:
                  update r-discount with frame f-res.
                  b-res.discount = r-discount.
                  leave.
               end.
               
               b-res.state = res-state-ch[res-state-placed].
               display res-state-ch[res-state-placed] @ r-state with frame f-res.
               
               SEL-GUEST:
               repeat on endkey undo UPDATE-RES, next UPDATE-RES:
                  g-f-n = "".
                  g-l-n = "".
                  g-dob = ?.
                  
                  g-id = ?.
                  update g-id help "Enter ? to search guest or guest-id"
                         with frame f-res.
    
                  find b-guest where b-guest.guest-id = g-id no-lock no-error.
                  if avail b-guest then do:
                     g-f-n = b-guest.first-name.
                     g-l-n = b-guest.last-name.
                     g-dob = b-guest.date-of-birth.
                     g-phone# = b-guest.phone-number.
                     
                     display g-f-n g-l-n g-dob g-phone# with frame f-res.
                  
                     b-res.guest-id = g-id.

                     leave SEL-GUEST.
                  end.
                  else do:
                     message "Guest not found!" view-as alert-box.
                  end.
               end.
               
               def var r-r-type like room.type-of-room.

               form
                  r-r-type format ">>>,>>>,>>>" view-as combo-box inner-lines 5  label "Room type"
                  skip
                  r-rooms label "No. of Rooms"
                     validate (r-rooms > 0, "Must set no. of rooms!")
                  with frame f-res-room side-labels.
               run set-room-types-combo (input r-r-type:handle in frame f-res-room).

               repeat on endkey undo UPDATE-RES, next UPDATE-RES:
                  r-r-type = 1.
                  update r-r-type r-rooms with frame f-res-room overlay centered title "Book Room".
                  
                  def var res-rooms as int.
                  def var total-rooms as int.
                  res-rooms = 0.
                  total-rooms = 0.
                  
                  for each room where room.type-of-room = r-r-type no-lock:
                     total-rooms = total-rooms + 1.
                  end.
                  
                  for each b-res2
                     where b-res2.checkin >= r-checkin and b-res2.checkout <= r-checkin and
                           b-res2.state <> res-state-ch[res-state-canceled] no-lock:
                     res-rooms = res-rooms + 1.
                  end.
                  
                  if total-rooms - res-rooms <= 0 then do:
                     message "No available [" + room-types[r-r-type] + "] rooms for " + string(r-checkin) " - " + string(r-checkout) + "!" view-as alert-box.
                     undo, retry.
                  end.
                  
                  create b-res-room.
                  b-res-room.reservation-id = r-id.
                  b-res-room.rooms = r-rooms.
                  b-res-room.type-of-room = r-r-type.

                  release b-res-room.
                  run refresh.

                  message "Add another?" view-as alert-box buttons yes-no update l-r-add as logical.
                  if not l-r-add then leave.
               end.

               r-del = false.
               leave.
            end.  
            
            if r-del then undo ADD-RES, leave ADD-RES.
               else leave ADD-RES.
         end.
         
         find reservation where reservation.reservation-id = r-id no-lock no-error. 
         run refresh.
      end.
      when "K" then do:
      
         /*
            checkin, create the records with:
            - reservation: set the state to "checked in"
            - checkout: 
            - checkout-rooms: 
                  set the room numbers for each room
                  set the guest-id's for each room (one or more)
          */

         if reservation.state <> "P" then do:
            message "Reservation must be in (P)laced state" view-as alert-box.
         end.
         else 
         R-CHECKIN:
         do transaction on error undo, leave
                        on endkey undo, leave:
            find b-res where b-res.reservation-id = r-id exclusive-lock.
            
            b-res.state = "I".
            
            create b-out.
            b-out.reservation-id = b-res.reservation-id.
            b-out.state = "I".
            b-out.room-charges = 0.
            b-out.sales-tax = 0.
            b-out.total = 0.
            
            for each b-res-room where b-res-room.reservation-id = b-res.reservation-id:
            
               def var ridx as int.
               
               do ridx = 1 to b-res-room.rooms on error undo R-CHECKIN, leave R-CHECKIN
                                               on endkey undo R-CHECKIN, leave R-CHECKIN:
                  create b-out-room.
                  b-out-room.reservation-id = b-res.reservation-id.
                  b-out-room.room-charges = 0.
                  b-out-room.laundry-charges = 0.
                  b-out-room.minibar-charges = 0.
                  
                  def var r-num as int.
                  
                  /* search for an available room */
                  open query q-rs-room 
                     for each b-room where b-room.type-of-room = b-res-room.type-of-room.
                  get first q-rs-room.

                  def var r-ok as log.

                  R-B-ROOM:
                  do while avail b-room:
                     message "checking " b-room.room-number.
                     
                     r-ok = yes.
                     
                     for each b-res2 where b-res2.checkin >= b-res.checkin and b-res2.checkin <= b-res.checkout no-lock,
                        each b-out-room2 
                           where recid(b-out-room2) <> recid(b-out-room) and 
                                 b-out-room2.room-number = b-room.room-number and
                                 b-out-room2.reservation-id = b-res2.reservation-id
                        no-lock:

                        r-ok = no.
                        leave.
                     end.
                     
                     if r-ok then do:
                        leave R-B-ROOM. 
                     end.
                     else do:
                        get next q-rs-room.
                     end.
                  end.
                  
                  if not avail b-room then do:
                     message "Can't find available room for [" + room-types[b-res-room.type-of-room] + "] in selected period!" view-as alert-box.
                     undo R-CHECKIN, leave R-CHECKIN.
                  end.
                  
                  R-RATE:
                  repeat:
                     b-out-room.room-number = b-room.room-number.
                     find last b-rate
                        where b-rate.type-of-room = b-room.type-of-room and
                              b-rate.start-date <= today and (b-rate.end-date = ? or b-rate.end-date >= today) 
                        use-index idx-rate-e-date no-lock no-error.
                     
                     if not avail b-rate then do:
                        find last b-rate
                           where b-rate.type-of-room = b-room.type-of-room and
                                 b-rate.end-date <= today 
                           use-index idx-rate-e-date no-lock no-error.
                     end.
                     
                     if not avail b-rate then do:
                        message "Can't find rate for room [" + room-types[b-room.type-of-room] + "] in booked period!".
                        leave R-RATE. 
                     end.
                     else do:
                        b-out-room.room-charges = b-rate.rate * (b-res.checkout - b-res.checkin).
                        leave.
                     end.
                  end.

                  def var gidx as int.
                  b-out.room-charges = b-out.room-charges + b-out-room.room-charges.
                  b-out-room.guest-ids = 0.
                  b-out-room.guest-ids[1] = ?.

                  clear frame f-room-guests.
                  frame f-room-guests:title = "Checkin room " + string(b-room.room-number) + " [" + room-types[b-room.type-of-room] + "]".
                  update b-out-room.guest-ids with frame f-room-guests.
               end.
            end.
         end.

         find reservation where reservation.reservation-id = r-id no-lock. 
         run refresh.
      end.
      when "C" then do:
         /* cancel the reservation */
         if reservation.state = "P"  
         then do transaction on error undo, leave 
                           on endkey undo, leave:
            message "Cancel current reservation?" update l-res-cancel as log view-as alert-box buttons yes-no-cancel.
            if l-res-cancel then do:
               find b-res where b-res.reservation-id = r-id exclusive-lock.
               b-res.state = "C".
               release b-res.
               run refresh.
            end.
         end.
         else do:
            message "Only processed reservations can be canceled".
            pause.
         end.
      end.
      when "D" then do:
         message "Delete current reservation?" update l-res-del as log view-as alert-box buttons yes-no-cancel.
         
         if l-res-del then do transaction:
            find b-res where b-res.reservation-id = r-id exclusive-lock.
            for each b-res-room where b-res-room.reservation-id = b-res.reservation-id exclusive-lock:
               delete b-res-room.
            end.
            
            delete b-res.
            
            selection = "P".
            next PROC.
         end.
      end.
      
      when "R" then do:
         publish "pop-program".
         leave PROC.
      end.
      otherwise do:
         if selection <> ? then do:
            message "Invalid selection - try again".
            selection = ?.
            pause.
            next. 
         end.
      end.
   end.

   if sprog <> ? then leave PROC.

   {wait-selection.i
      &sele1="(P)rev   (N)ext   (F)irst   (L)ast"
      &sele2="F(i)nd   (A)dd   (D)elete   Chec(k) in   (C)ancel   "
      }
end.

if sprog <> ? then do:
   publish "push-program" (sprog).
end.
